#[doc = "Register `IMO_MAXF1` reader"]
pub struct R(crate::R<IMO_MAXF1_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<IMO_MAXF1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<IMO_MAXF1_SPEC>> for R {
    fn from(reader: crate::R<IMO_MAXF1_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `IMO_MAXF1` writer"]
pub struct W(crate::W<IMO_MAXF1_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<IMO_MAXF1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<IMO_MAXF1_SPEC>> for W {
    fn from(writer: crate::W<IMO_MAXF1_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `MAXFREQ` reader - Max frequency (3..48) at which IMO_ABS/TMPCO3 is valid (range is IMO_MAXF2+1 .. IMO_MAXF3)."]
pub struct MAXFREQ_R(crate::FieldReader<u8, u8>);
impl MAXFREQ_R {
    pub(crate) fn new(bits: u8) -> Self {
        MAXFREQ_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for MAXFREQ_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `MAXFREQ` writer - Max frequency (3..48) at which IMO_ABS/TMPCO3 is valid (range is IMO_MAXF2+1 .. IMO_MAXF3)."]
pub struct MAXFREQ_W<'a> {
    w: &'a mut W,
}
impl<'a> MAXFREQ_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x3f) | (value as u8 & 0x3f);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:5 - Max frequency (3..48) at which IMO_ABS/TMPCO3 is valid (range is IMO_MAXF2+1 .. IMO_MAXF3)."]
    #[inline(always)]
    pub fn maxfreq(&self) -> MAXFREQ_R {
        MAXFREQ_R::new((self.bits & 0x3f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:5 - Max frequency (3..48) at which IMO_ABS/TMPCO3 is valid (range is IMO_MAXF2+1 .. IMO_MAXF3)."]
    #[inline(always)]
    pub fn maxfreq(&mut self) -> MAXFREQ_W {
        MAXFREQ_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Max frequency for trim pair\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [imo_maxf1](index.html) module"]
pub struct IMO_MAXF1_SPEC;
impl crate::RegisterSpec for IMO_MAXF1_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [imo_maxf1::R](R) reader structure"]
impl crate::Readable for IMO_MAXF1_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [imo_maxf1::W](W) writer structure"]
impl crate::Writable for IMO_MAXF1_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets IMO_MAXF1 to value 0"]
impl crate::Resettable for IMO_MAXF1_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
